Ошибка закрытого сокета Django с повторными вызовами AJAX [WinError 10053] Установленное соединение было прервано программным обеспечением на вашем хост-компьютере

python ajax django jquery-select2 django-wsgi

398 просмотра

1 ответ

Я пытаюсь реализовать живой поиск через плагин jquery Select2 в моем проекте Django 1.11.4. Запуск Python 3.6. Когда я набираю текстовое поле, сервер не может обработать количество запросов и закрывается, после чего следует ряд ошибок. Я провел пару часов, следуя нескольким потокам в SO SO (подробнее) , Google и т. Д., Но ни у одного из них нет работающего решения. Я думал, что это проблема версии Python, но я обновился с 2,7 до 3,6 и до сих пор есть. Любая помощь будет большой благодарностью!

Это представление, вызываемое вызовом ajax:

  def directory_search(request):
      # Query text from search bar
      query = request.GET.get('q', None)
      if query:

          # Searches the DB for matching value
          customers = Customer.objects.filter(
              Q(name__icontains= query)|
              Q(contract_account__icontains= query)|
              Q(address__icontains= query)|
              Q(address__icontains= query)|
              Q(email__icontains= query)
              ).distinct()
          # Turns queryset into dict
          customers = customers.values("contract_account","name")
          # Turns dict into list
          customers_list = list(customers)

          return JsonResponse(customers_list, safe=False)
      else:
          return JsonResponse(data={'success': False,'errors': 'No mathing items found'})

Это вызов js / ajax для плагина Select2:

  $(".customer-search-bar").select2({
    ajax:{
      dataType: 'json',
      type: 'GET',
      url:"{% url 'portal:directory_search' %}",
      data: function (params) {
          var queryParameters = {
              q: params.term
          }
          return queryParameters;
      },
      processResults: function (data) {
          return {
              results: $.map(data, function (item) {
                  return {
                      text: item.name,
                      id: item.contract_account
                  }
              })
          };
      }
    },
    escapeMarkup: function (markup) { return markup; },
    minimumInputLength: 1,
    templateResult: formatRepo,
    templateSelection: formatRepoSelection,
    language: { errorLoading:function(){ return "Searching..." }}
  });

Ошибки: (Я просто разбил их на части, чтобы сделать их более разборчивыми, но они произошли в представленном порядке)

1.

Traceback (most recent call last):
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 138, in run
    self.finish_response()
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 180, in finish_response
    self.write(data)
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 274, in write
    self.send_headers()
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 332, in send_headers
    self.send_preamble()
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 255, in send_preamble
    ('Date: %s\r\n' % format_date_time(time.time())).encode('iso-8859-1')
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 453, in _write
    result = self.stdout.write(data)
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\socketserver.py", line 775, in write
    self._sock.sendall(b)
ConnectionAbortedError: [WinError 10053] An established connection was aborted by the software in your host machine

2.

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 141, in run
    self.handle_error()
  File "C:\Users\leep\PythonStuff\virtual_environments\rpp_3.6\lib\site-packages\django\core\servers\basehttp.py", line 88, in handle_error
    super(ServerHandler, self).handle_error()
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 368, in handle_error
    self.finish_response()
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 180, in finish_response
    self.write(data)
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 274, in write
    self.send_headers()
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 331, in send_headers
    if not self.origin_server or self.client_is_modern():
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 344, in client_is_modern
    return self.environ['SERVER_PROTOCOL'].upper() != 'HTTP/0.9'
TypeError: 'NoneType' object is not subscriptable

3.

During handling of the above exception, another exception occurred:
Traceback (most recent call last):
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\socketserver.py", line 639, in process_request_thread
    self.finish_request(request, client_address)
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\socketserver.py", line 361, in finish_request
    self.RequestHandlerClass(request, client_address, self)
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\socketserver.py", line 696, in __init__
    self.handle()
  File "C:\Users\leep\PythonStuff\virtual_environments\rpp_3.6\lib\site-packages\django\core\servers\basehttp.py", line 155, in handle
    handler.run(self.server.get_app())
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\handlers.py", line 144, in run
    self.close()
  File "C:\Users\leep\AppData\Local\Programs\Python\Python36-32\lib\wsgiref\simple_server.py", line 35, in close
    self.status.split(' ',1)[0], self.bytes_sent
  AttributeError: 'NoneType' object has no attribute 'split'
Автор: trickly Источник Размещён: 28.09.2019 05:55

Ответы (1)


0 плюса

Похоже, что это известная ошибка на Python 2.7, возможно, она остается на Python 3.6:

https://bugs.python.org/issue14574

У меня похожая проблема в django, также работает Python 3.6 TypeError: объект 'NoneType' не является подписным, после которого следует AttributeError: объект 'NoneType' не имеет атрибута 'split'

редактировать

Вроде бы ошибка на хроме. Это не дошло до меня, потому что я использовал Opera, но опера также использует хром. В интернет-проводнике ошибку не показывали.

https://code.djangoproject.com/ticket/21227#no1

Это трекер ошибок

Автор: EduardoMaia Размещён: 28.09.2017 05:30
Вопросы из категории :
32x32